﻿#define _NOT_USE_PYTHON_SPR_LIB

#include "Python.h"

#include <EmbPython\EmbPython.h>
#include <EmbPython\SprEPUtility.h>

#include "SprBlenderDLL.h"

#include "SprEPSprBlenderDLL.h"
#include "EPSprBlenderDLL.h"

// --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
// WndProc書き換え用
LRESULT CALLBACK NewWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
WNDPROC OldWndProc;

// シングルトン
SprBlenderDLL* SprBlenderDLL::app = NULL;

// 初期化
void SprBlenderDLL::Init() {
	hiSdk = HISdkIf::CreateSdk();

	// --- --- --- --- ---
	// SpaceNavigator
	// HWND hWnd = FindWindow(L"GLUT", L"Python with Springhead");
	HWND hWnd = GetActiveWindow();
	HISpaceNavigatorDesc descSN;
	descSN.hWnd = &hWnd;

	spaceNavigator = hiSdk->CreateHumanInterface(HISpaceNavigatorIf::GetIfInfoStatic())->Cast();
	spaceNavigator->Init(&descSN);
	spaceNavigator->SetPose(Posef(Vec3f(0,0,5.0), Quaternionf()));

	// ウィンドウプロシージャを置き換え
	OldWndProc = (WNDPROC)(GetWindowLongPtr(hWnd, GWLP_WNDPROC));
	SetWindowLongPtr(hWnd, GWLP_WNDPROC, (LONG_PTR)(NewWndProc));
}

// --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
// 置き換え用WndProc
LRESULT CALLBACK NewWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	MSG m;
	m.hwnd		= hWnd;
	m.message	= msg;
	m.wParam	= wParam;
	m.lParam	= lParam;
	SprBlenderDLL* app = SprBlenderDLL::GetInstance();
	if (app->IsSpaceNavigatorUsed() && app->spaceNavigator->PreviewMessage(&m)) {
		return 0L;
	}
	return CallWindowProc(OldWndProc, hWnd, msg, wParam, lParam);
}

// --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---

static PyMethodDef Spr_methods[] = {
	{NULL, NULL}
};

static struct PyModuleDef Sprmodule = {
	PyModuleDef_HEAD_INIT,
	EP_MODULE_NAME,
	"Springhead on Python",
	-1,
	Spr_methods,
	NULL,
	NULL,
	NULL,
	NULL
};

// --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
// Python <=> Springhead 変数接続用
#define ACCESS_SPR_FROM_PY(cls, name, obj)							\
	{																\
		PyObject* pyObj = (PyObject*)newEP##cls((obj));				\
		Py_INCREF(pyObj);											\
		PyDict_SetItemString(dict, #name, pyObj);					\
	}																\

extern "C" __declspec(dllexport) PyObject* _cdecl PyInit_Spr(void) {
	PyObject *module_Spr;
	module_Spr = PyModule_Create(&Sprmodule);
	PyObject *dict = PyModule_GetDict(module_Spr);

	initUtility();
	initBase(module_Spr);
	initFoundation(module_Spr);
	initFileIO(module_Spr);
	initCollision(module_Spr);
	initPhysics(module_Spr);
	initGraphics(module_Spr);
	initCreature(module_Spr);
	initHumanInterface(module_Spr);
	initFramework(module_Spr);

	initSprBlenderDLL();

	SprBlenderDLL* app = SprBlenderDLL::GetInstance();
	ACCESS_SPR_FROM_PY(SprBlenderDLL, app, app);

	return module_Spr;
}
